#!/usr/local/bin/perl 

&PrintHeader;
&ReadParse;

sub ReadParse {
  local (*n) = @_ if @_;
  local ($i, $key, $val);
if (&MethGet) {
    $in = $ENV{'QUERY_STRING'};
} elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
  read(STDIN, $in, $ENV{'CONTENT_LENGTH'});
}
#print '$in= ', $in, "/n/n/n", '<p>';
@in = split(/&/, $in);
foreach $i (0 .. $#in) {
  $in[$i] =~ s/\+/ /g;
  ($key, $val) = split(/=/, $in[$i],2);
  $key =~ s/%(..)/pack("c",hex($1))/ge;
  $val =~ s/%(..)/pack("c",hex($1))/ge;
  $in{$key} .= "\0" if (defined($in{$key}));
  $in{$key} .= $val;
  }

($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time());
$file_name = $in{"file_name"};

foreach $key(sort (keys %in)) {
#print '$in{$key} = ', $in{$key}, "\n", '<br>';
  $column_constraint{$key} = $in{$key} if ($in{$key}=~/[\w]/ && $key=~/column_constraint[0-9]+/);
  $column_constraint_input{$key} = $in{$key} if ($in{$key}=~/[\w]/ && $key=~/column_constraint_input[0-9]+/);
  $column_description{$key} = $in{$key} if ($in{$key}=~/[\w]/ && $key=~/column_description[0-9]+/);
  $column_name{$key} = $in{$key} if ($in{$key}=~/[\w]/ && $key=~/column_name[0-9]+/);
  $column_type{$key} = $in{$key} if ($in{$key}=~/[\w]/ && $key=~/column_type[0-9]+/); 
  $column_type_num{$key} = $in{$key} if ($in{$key}=~/[\w]/ && $key=~/column_type_num[0-9]+/);
  $column_type_num_input{$key} = $in{$key} if ($in{$key}=~/[\w]/ && $key=~/column_type_num_input[0-9]+/); 
#  print $key, ' = ', $in{$key}, "\n", '<br>';
}
print '%column_constraint = ', %column_constraint, "<br>\n";
print %column_constraint_input, "\n";
print %column_description, "\n";
print %column_name, "\n";
print %column_type, "\n";
print %column_type_num, "\n";
print %column_type_num_input, "\n";



  open (WRITE_PACKAGE, ">/home/B11B/jguo/osprey7/test.sql")||die("Can't open file: zualum-text.html");
  open (WRITE_TABLE, ">/home/B11B/jguo/osprey7/test_table.sql")||die("Can't open file: zualum-link.html");
  open (WRITE_HTML, ">/home/B11B/jguo/osprey7/test.html")||die("Can't open file: zualum-info.html");

  
  write (WRITE_PACKAGE);
  write (WRITE_TABLE);
  write (WRITE_HTML);

  close (WRITE_PACKAGE);
  close (WRITE_TABLE);
  close (WRITE_HTML);
  
  print 'PulsarTool has created a new database application. ';
  print "<li><a href=\"/osprey7/$filename\.sql\"> $filename\.sql<br>";
  print "<li><a href=\"/osprey7/$filename\_table.sql\"> $filename\_table.sql<br>";
  print "<li><a href=\"/osprey7/$filename\.html\"> $filename\.html<br>";

  print '<li><a href="/osprey7/test_table.sql"> test_table.sql<br>';
  print '<li><a href="/osprey7/test.html"> test.html<br>';

  return length($in);
}

sub PrintHeader {
#   return "Content-type: text/html\n\n";
    print "Content-type: text/html\n\n";
}

sub MethGet {
  return ($ENV{'REQUEST_METHOD'} eq "GET");
}

sub print_arguments {
  $i = 0;
  foreach $key (sort keys%column_name) {
    $i = $i + 1;
    $key =~ /\w+(\d+)$/;
    $column_name = $column_name{$key};
    $column_type = $column_type{"column_type$1"};
    $comma = ",\n    "; 
    $comma = "" if ($i =~ /1/);
    $result1 .= "$comma\i$column_name in $column_type";
  }
  return $result1;
}

sub print_columns {
  local($j);
  $j = 0;
  foreach $key (sort keys%column_name) {
    $j = $j + 1;
    $key =~ /\w+(\d+)$/;
    $column_constraint = $column_constraint{"column_constraint$1"};
    $column_constraint_input = $column_constraint_input{"column_constraint_input$1"};
    $column_description = $column_description{"column_description$1"};
    $column_name = $column_name{$key};
    $column_type = $column_type{"column_type$1"};
    $column_type_num = $column_type_num{"column_type_num$1"};
    $column_type_num_input = $column_type_num_input{"column_type_num_input$1"};

    $column_type_num = $column_type_num_input if defined($column_type_num_input); 
    $column_constraint = $column_constraint_input if defined($column_constraint_input); 
    $comma = ","; 
    $comma = "" if ($j = length(%column_name) );
#print(length(%column_name)."IIIIII$j");    
    $result2 .= "$column_name\t$column_type";
    $result2 .= "($column_type_num)" || ($column_type_num =~/^[0-9]+$/);
    $result2 .= " $column_constraint" || ($column_constraint =~/^\w+$/);
    $result2 .= "$comma\t-- $column_description\n    ";
  }
  return $result2;
}

sub print_insert {
  $i = 0;
  $result1 = "";
  foreach $key (sort keys%column_name) {
    $i = $i + 1;
    $key =~ /\w+(\d+)$/;
    $column_name = $column_name{$key};
    $column_type = $column_type{"column_type$1"};
    $comma = ",\n    "; 
    $comma = "" if ($i =~ /1/);
    $result1 .= "$comma\iorow.$column_type";
  }
  return $result1;
}

sub print_update {
  $i = 0;
  $result1 = "";
  foreach $key (sort keys%column_name) {
    $i = $i + 1;
    $key =~ /\w+(\d+)$/;
    $column_name = $column_name{$key};
    $column_type = $column_type{"column_type$1"};
    $comma = ",\n    "; 
    $comma = "" if ($i =~ /1/);
    $result1 .= "$comma$column_name = iorow.$column_type";
  }
  return $result1;
}

sub print_insert_action {
  $i = 0;
  $result1 = "";
  foreach $key (sort keys%column_name) {
    $i = $i + 1;
    $key =~ /\w+(\d+)$/;
    $column_name = $column_name{$key};
    $column_type = $column_type{"column_type$1"};
    $comma = ",\n    "; 
    $comma = "" if ($i =~ /1/);
    $result1 .= "$comma\this.$column_name = i$column_type";
  }
  return $result1;
}

sub print_search_page {
   $result1 = "";
  foreach $key (sort keys%column_name) {
    $key =~ /\w+(\d+)$/;
    $column_name = $column_name{$key};
    $column_type = $column_type{"column_type$1"};
    $result1 .= "htp.p(\'<tr>\')";
    $result1 .= "htp.p(\'<th>$column_name<\th>\')";
    $result1 .= "htp.p(\'<td>\'||this.$column_name\||\'<\td>\')";
    $result1 .= "htp.p(\'<\tr>\n    \')";
  }
  return $result1;
}

sub print_insert_page {
   $result1 = "";
   foreach $key (sort keys%column_name) {
    $key =~ /\w+(\d+)$/;
    $column_name = $column_name{$key};
    $column_type = $column_type{"column_type$1"};
    $result1 .= "htp.p(\'<tr>\')";
    $result1 .= "htp.p(\'<th>$column_name<\th>\')";
    $result1 .= "htp.p(\'<td> <input type=\"text\" size=50 value=\"\"><\td>\')";
    $result1 .= "htp.p(\'<\tr>\n    \')";
  }
  return $result1;
}

sub print_update_page {
  $result1 = "";
  foreach $key (sort keys%column_name) {
    $key =~ /\w+(\d+)$/;
    $column_name = $column_name{$key};
    $column_type = $column_type{"column_type$1"};
    $result1 .= "htp.p(\'<tr>\')";
    $result1 .= "htp.p(\'<th>$column_name<\th>\')";
    $result1 .= "htp.p(\'<td> <input type=\"text\" size=50"; 
    $result1 .= " value=\"\'||this.$column_name\||\'\"><\td>\')";
    $result1 .= "htp.p(\'<\tr>\n    \')";
  }
  return $result1;
}

format WRITE_PACKAGE =
--************************************************************
--*    This file is created by NPAC PL/SQL Module Creator    *
--*    on @>/@|/@< @>:@|:@<.                                 *
        $mon $mday $year $hour $min $sec                 
--*    Contact jguo@npac.syr.edu for more information.       *  
                  '@'                   
--************************************************************

------------------------------------------------------------
----  drop previous version of the package             -----
------------------------------------------------------------

drop package @*
             "$file_name\;"
/

----------------------------------------------------  
create or replace package @*
                          "$file_name is"  
----------------------------------------------------  
  procedure rm (
    iid in varchar2
  );
  function get (
    iid in varchar2
  ) return @*
           "$file_name\_table\%rowtype;"
  procedure put (
    iorow in out @*
                 "$file_name\_table\%rowtype"
  );
  function new ( 
    iorow in out @*
                 "$file_name\_table\%rowtype"
  ) return @*
           "$file_name\_table.id\%rowtype;"
  function next (
    iorow in out @*
                 "$file_name\_table\%rowtype"
  ) return boolean;
  procedure insert_action (
    @*
    &print_arguments
  );
  procedure update_action (
    @*
    &print_arguments
  );
  procedure delete_action (
    iid in varchar2
  ); 
  procedure search_page (
    iid in varchar2
  );  
  procedure insert_page;  

  procedure delete_page (
    iid in varchar2
  );  
  procedure echo_page ( 
    iid in varchar2, 
    iaction in varchar2
  );  

end;  
/
show errors;
/

---------------------------------------------------------  
create or replace package body @*
                               "$file_name is"  
---------------------------------------------------------  
  this @*
       "$file_name\_table\%type;"
  cursor nrow is select * from @*
                               "$file_name\_table order by day;"

  procedure rm (iid in varchar2) is
    begin
      delete from @*
                  "$file_name\_table" 
        where id = iid;
      exception
        when no_data_found then
          raise;
        when others then
          print_error('rm');
  end;

  function get(
    iid in varchar2
  ) return @*
           "$file_name\_table\%rowtype is"
    cursor c (this_id number) is
      select * from @*
                    "$file_name\_table the"
      where the.id = this_id;
  begin
    open c (iid);
    fetch c into this;
    if c\%notfound then
      raise no_data_found;
    end if;
    close c;
    return this;
    exception
      when no_data_found then
        raise;
      when others then
        print_error('get');
  end;

  procedure put(
    iorow in out @*
                 "$file_name\_table\%rowtype) is"
    cursor c (
      this_id number
    ) is
      select * from @*
                    "$file_name\_table"
        where id = this_id;
    begin
      if (iorow.id is null) then
	select @*
               "$file_name\_seq.nextval into iorow.id"
	  from dual;
        insert into @*
                    "$file_name\_table"
	  values (
                @*
                &print_insert
              
	    );
      else
        open c (iorow.id);
	fetch c into this;
	if c\%found then
	  update  @*
                  "$file_name\_table set"
                @*
                &print_update
	  where id = iorow.id;
	else
	  raise no_data_found;
	end if;
        close c;
      end if;
    exception
      when no_data_found then
        raise;
      when others then
        print_error('put');
    end;

  function new (
    iorow in out @*
                 "$file_name\_table\%rowtype"
  ) return @*
           "$file_name\_table.id\%type is"
  begin
    iorow.id := null;
    put(iorow);
    return iorow.id;
    exception
      when no_data_found then
        raise;
      when others then
        print_error('new');
  end;

  function next (
    ionrow in out @*
                  "$file_name\_table\%rowtype"
  ) return boolean is
  begin
    if not nrow\%isopen then
      open nrow;
    end if;
    fetch nrow into ionrow;
    if nrow\%notfound then
      close nrow;     
      return false;
    else
      return true;
    end if;
  exception
    when others then
        print_error('next');
  end;

  procedure insert_action (
    @*
    &print_arguments 
  ) is
    @*
    &print_insert_action
    this.id := new(this);
    echo_page(this, 'inserted');
    exception
      when others then
        print_error('insert_action');
  end;  

  procedure update_action (
    @*
    &print_arguments 
  ) is
  begin  
    @*
    &print_insert_action
    put(this);
    echo_page(this, 'updated');
    exception
      when others then
        print_error('update_action');
  end;  

  procedure delete_action ( 
    iid in varchar2
  ) is
  begin  
    this.id := iid;
    rm(to_number(iid));
    echo_page(this, 'deleted');
    exception
      when others then
        print_error('delete_action');
  end;  

  procedure search_page (
    iid in varchar2
  ) is  
  begin 
    select * from @*
                  "$file_name"
      where id = iid
      into this; 
    htp.p('<table>);
    @*
    &print_search_page
    htp.p('<\table>);
    exception
      when others then
        print_error('search_page');
  end;  

  procedure insert_page is  
  begin  
    select * from @*
                  "$file_name"
      where id = iid
      into this; 
    htp.p('<form action="/cgi-bin/wow/@*
                                      "$file_name\.insert_action\"' method=\"POST\">;"
    htp.p('<table>);
    @*
    &print_insert_page
    htp.p('<\table>);
    htp.p('<\form>);
    exception
      when others then
        print_error('insert_page');
  end;  

  procedure update_page (
    iid in varchar2
  ) is  
    select * from @*
                  "$file_name"
      where id = iid
      into this; 
  begin  
    htp.p('<form action="/cgi-bin/wow/@*
                                      "$file_name\.insert_action\"\' method=\"POST\">;"
    htp.p('<table>);
    @*
    &print_update_page
    htp.p('<\table>);
    htp.p('<\form>);
    exception
      when others then
        print_error('update_page');
  end;  

  procedure delete_page (
    iid in varchar2
  ) is  
  begin  
    htp.p('<form action="/cgi-bin/wow/@*
                                     "$file_name\.delete_action\"\' method=\"POST\">;"
    htp.p('<h2>Are you sure to delete this record?</h2>'
      || htf.formSubmit(null, 'Delete')); 
    htp.formHidden('iid', iid);
    search_page(this);
    htp.formClose;
    exception
      when others then
        print_error('delete_page');
  end;  

  procedure echo_page (
    iid in varchar2, 
    iaction in varchar2
  ) is  
  begin  
   htp.p('<head>');
   htp.p('</head>');
   htp.p('<body>');
   htp.p('<h1>The following record has been'|| iaction || '</h1>'); 
   search_page(iid);
   htp.p('</body>');
    exception
      when others then
        print_error('insert_page');
  end;  

end;  
---------------------------------------------------------  
/
show errors
/
.

#------------------------------------------------------------
format WRITE_TABLE = 
drop sequence @*
              "$file_name\_seq;"
drop table  @*
            "$file_name\_table;"

create sequence @*
                "$file_name\_seq;"

create TABLE @*
             "$file_name (" 
  @*
  &print_columns
);
/
show errors
/
.

#------------------------------------------------------------
format WRITE_HTML = 
<html>
<head>
<title>NPAC Patient Record Database</title>
<script language="JavaScript">

<!--scriptbegin
var date_start = new Date();
var date_curr = date_start;
var time_start = date_start.getTime();
var time_curr = time_start;
var date_rel = new Date();
var time_rel = 0;

//scriptend-->

</script>
</head>
<frameset rows="100,*,64">
<frame name="bar" src="Bar.html" marginwidth=1 marginheight=1
scrolling=0 noresize>
<frameset cols="200,*,200">
<frameset rows="150,50,*">
<frame name="cntl" src="Cntl.html">
<frame name="action" src="Search.html">
<frame name="list" src="List.html" marginwidth="1">
</frameset>
<frame name="record" src="Help.html">
<frame name="items" src="Items.html" marginwidth="1">
</frameset>
<frame name="sign" src="Sign.html">

<noframes>
Your browser does not support multiple frames and JavaScript. Please use 
a Netscape 2.0 browser to view the [JavaScript enabled versoin]. 
Or you may  
<a href="/jguo/db1/Main1.html>[Go to Netscpae 1.1 version]</a>.
<\noframes>

</frameset>
</html>
.
1;
